#ifndef ATTACK_H
#define ATTACK_H

#include "Board.h"
#include "Bitboard.h"

// Attack definition:
// - set of squares a piece can reach with a potential capture move
// - the target square can be empty (or occupied by the other color but not implemented like this for now)


// TODO: complete this pseudo class with bitboard types
struct attack_t {
  Bitboard allAttacks;

  Bitboard pawnMobility; // TODO: calculate this part
  Bitboard pawnAttacks;
  Bitboard knightAttacks;
  Bitboard kingAttacks;
  Bitboard bishopAttacks;
  Bitboard rookAttacks;
  Bitboard queenAttacks;
};

// TODO: complete part with 
void get_attacks(Board& board, Color side, attack_t& attack);
bool IsInCheck(Board& board, Color side, attack_t& attack);


Bitboard get_bishop_attacks(Board& board, Square& sq);
Bitboard get_rook_attacks(Board& board, Square& sq);
Bitboard get_pinned(Board& board, Color side);

void pinScanUp(Square sqStart, Square sqEnd, Square sqStep, Bitboard& potPinned, Bitboard& potAttackers, Bitboard& pinned);
void pinScanDown(Square sqStart, Square sqEnd, Square sqStep, Bitboard& potPinned, Bitboard& potAttackers, Bitboard& pinned);

#endif
