#ifndef BOARD_H
#define BOARD_H

#include "Types.h"
#include "Bitboard.h"
using namespace Bitboards;

#define PIECEBB_SIZE 16

class Board {

public:
	Board();
	~Board();
	
	Piece pieces[64];
	Bitboard piecesBB[PIECEBB_SIZE];
	Bitboard emptyBB;
	Bitboard occupiedBB;
	Bitboard colorBB[2];
	// TODO: implement one-time-eval attack bitboard (for ischeck, legalmovegen & mobilityeval)
	
	void Init();
	void Copy(Board & b_src);
	
	void Clear();
	void ClearSquare(int square);
	void SetPiece(Piece piece, Square square);
	Piece GetPiece(Square square);
	void DoMove(Move move);
	void UndoMove(Move move, Piece piece, Piece cPiece);
	
	bool IsSquareEmpty(Square square);
	bool IsEqual(Board & b2);
	
	int Evaluate();
	void DebugDisplay();
	
	char PieceToChar(Piece p);
	bool IsCheck(Color side);
	bool IsCheckOnSquare(Square square, Color bySide);
	
	bool IsEmptyOrColor(Square square, Color bySide);

  //Key zobrist;
	
};


bool board_is_correct(Board* b);
int count_pieces(Board* b);


#endif
