#ifndef DEBUGTEST_H
#define DEBUGTEST_H

#include <map>
#include <string>

class DebugTest {

public:
	void LaunchTests();
  void Sandbox();
	void TestLegalMoves(map<string,string> & legalMovesDatabase);
	bool TestPlayUnplayMoves(map<string,string> & legalMovesDatabase,  bool verbose);
	void TestSearch();
	void TestEloAdjustment(map<string,string> & testPositions, int thinkTime);
	void TestExpectedBestMove(map<string,string> & bestMovesDatabase, int duration);
	bool TestComparedSearch(map<string,string> & testPositions, int duration, string imp1, string imp2);

	void TestAlphaBetaIter();
	void TestBitboards();
	void DisplayResults(string title, map<string, string> summary);

	void initLegalMovesDatabase(map<string,string> & testPositions);
	void initBestMovesDatabase(map<string,string> & bestMovesDatabase);
	void initMatesDatabase(map<string,string> & matesDatabase);
	void initNoCheck(map<string,string> & noCheck);
	void initInCheck(map<string,string> & inCheck);
	void initInCheckmate(map<string,string> & inCheckmate);
	
	void TestBitBoardLocalEval();
	void TestPositionLoading();
	void TestBitBoards();
	void TestIsCheck(map<string,string> & noCheck, map<string,string> & inCheck, map<string,string> & inCheckmate);
	void DisplayNonVerboseTestResult(string testFctName, bool result);
	bool IsEqual(list_t expected, list_t list);
	void TestOptions();
	void TestHashCode();
	int GetNbPieces(Position& position);
	void DisplayMoves(list_t moves);

	void DisplayCheckStatus(Position& position);
	void StringToMoves(string s, list_t& moves);
};

#endif
