#ifndef EVAL_H
#define EVAL_H

#include "Board.h"

// global properties (declared in .cpp)
extern int queenWeight;
extern int rookWeight;
extern int bishopWeight;
extern int knightWeight;
extern int pawnWeight;

extern int kingMobilityFactor;
extern int queenMobilityFactor;
extern int rookMobilityFactor;
extern int bishopMobilityFactor;
extern int knightMobilityFactor;
extern int pawnMobilityFactor;

extern int pawnStructureFactor;

// functions
int EvaluateBoard(Board& b);
int EvaluateBoard(Board& b, Color turn);
int EvaluateBoard(Board& b, Color turn, int depth);
int EvaluateStaticScore(Board& b);
int EvaluateMobilityScore(Board& board);
int EvaluatePawnHandicapScore(Board& board);

#endif
