#ifndef MOVEGEN_H
#define MOVEGEN_H

#include <map>
#include "Types.h"
#include "Position.h"
#include "Move.h"
#include "Attack.h"

// old implementation (generate, then prune illegal moves) 

int GetLegalMoves(Position& pos, list_t & moves); 
void GetPossibleMoves(Position& position, list_t& moves);
void GetPossibleMoves(Position& position, Square square, list_t & possibleMoves);
//void GetPossibleMovesBB(Position& position, list_t& moves);

void GetPossibleKingMoves(Position& position, Square square, list_t & possibleKingMoves);
void GetPossibleQueenMoves(Position& position, Square square, list_t & possibleQueenMoves);
void GetPossibleRookMoves(Position& position, Square square, list_t & possibleRookMoves);
void GetPossibleKnightMoves(Position& position, Square square, list_t & possibleKnightMoves);
void GetPossibleBishopMoves(Position& position, Square square, list_t & possibleBishopMoves);
void GetPossiblePawnMoves(Position& position, Square square, list_t & possiblePawnMoves);

/*
void GetPossibleKingMoves(Position& position, list_t & captureMoves, list_t & quietMoves, list_t& castleMoves );
void GetPossibleQueenMoves(Position& position, list_t & captureMoves, list_t & quietMoves);
void GetPossibleRookMoves(Position& position, list_t & captureMoves, list_t & quietMoves);
void GetPossibleKnightMoves(Position& position, list_t & captureMoves, list_t & quietMoves);
void GetPossibleBishopMoves(Position& position, list_t & captureMoves, list_t & quietMoves);
void GetPossiblePawnMoves(Position& position, list_t & captureMoves, list_t & quietMoves, list_t& promMoves, list_t& enpassantMoves);
*/

// new implementation (generate good moves only)
//extern int GenLegalMoves(Position& pos, list_t& moves); 
int potentialValue(Move move);
void SetMvvLvaValue(list_t& list, Position& p);
int MvvLvaValue(Position& pos, Move move);

/*
void GenEvasionMoves(Position& pos, attack_t& attackSide, attack_t& attackOpp, Bitboard& pinned, list_t& moves);
void GenCastleMoves(Position& pos, attack_t& attackSide, attack_t& attackOpp, Bitboard& pinned, list_t& moves);

void GenQuietMoves(Position& pos, attack_t& attackSide, attack_t& attackOpp, Bitboard& pinned, list_t& moves);
void GenQuietPawnMoves(Position& pos, attack_t& attackSide, attack_t& attackOpp, Bitboard& pinned, list_t& moves);
void GenQuietKnightMoves(Position& pos, attack_t& attackSide, attack_t& attackOpp, Bitboard& pinned, list_t& moves);
void GenQuietKingMoves(Position& pos, attack_t& attackSide, attack_t& attackOpp, Bitboard& pinned, list_t& moves);
void GenQuietRookMoves(Position& pos, attack_t& attackSide, attack_t& attackOpp, Bitboard& pinned, list_t& moves);
void GenQuietBishopMoves(Position& pos, attack_t& attackSide, attack_t& attackOpp, Bitboard& pinned, list_t& moves);
void GenQuietQueenMoves(Position& pos, attack_t& attackSide, attack_t& attackOpp, Bitboard& pinned, list_t& moves);

void GenCaptureMoves(Position& pos, attack_t& attackSide, attack_t& attackOpp, Bitboard& pinned, list_t& moves);
void GenCapturePawnMoves(Position& pos, attack_t& attackSide, attack_t& attackOpp, Bitboard& pinned, list_t& moves);
void GenCaptureKnightMoves(Position& pos, attack_t& attackSide, attack_t& attackOpp, Bitboard& pinned, list_t& moves);
void GenCaptureKingMoves(Position& pos, attack_t& attackSide, attack_t& attackOpp, Bitboard& pinned, list_t& moves);
void GenCaptureRookMoves(Position& pos, attack_t& attackSide, attack_t& attackOpp, Bitboard& pinned, list_t& moves);
void GenCaptureBishopMoves(Position& pos, attack_t& attackSide, attack_t& attackOpp, Bitboard& pinned, list_t& moves);
void GenCaptureQueenMoves(Position& pos, attack_t& attackSide, attack_t& attackOpp, Bitboard& pinned, list_t& moves);
*/

void InitLegalMoves(list_t & legalMoves);
void SortByPotential(list_t& moves);
//void SetPotentialValue(Position& pos, list_t& t);
//int potentialValue(Position& pos, Move move);
void SetHistoryValue(list_t& list, Position& p);

//Piece GetCPiece(Position& pos, Move move);
//Piece GetMPiece(Position& pos, Move move);
int GetVal(Piece p);

// Pruning and move ordering
//void futility_pruning(Position& pos, list_t& t);
void SetPotentialValue(list_t& list);
void pv_reorder(list_t& moveList, map<Move,Move*> pvhash);

#endif
